% Define the necessary path directories
DefinePath;

%% Make all the MEX files
mex PointToLineDist_MEX.cpp
cd Ncut_9\
compileDir_simple
cd ..
disp('Remember to make svm-lite if the precompiled files don''t work for you');

%% Part Detection

% Load the trained classifier for superpixel affinities
load classifier_params_svm

% Detect symmetric parts
filename = 'Images\fan.jpg';
img = im2double(imread(filename));

% % % Detect symmetric parts - recompute all data (SLOW !!!)
% % [parts, part_scales, part_score, image_data] = DetectSymmetricParts_SingleImage(filename, classifier_params, true);

% % % Detect symmetric parts (only 2 superpixels or more)
% % [parts, part_scales, part_score, image_data] = DetectSymmetricParts_SingleImage(filename, classifier_params);

% Detect symmetric parts (single-superpixel parts are allowed)
[parts, part_scales, part_score, image_data] = DetectSymmetricParts_SingleImage(filename, classifier_params, [], [], [], [], true);

% Display multiscale superpixels
figure(1);
DisplayMultiscaleSuperpixels(filename, [], 1);

% Display the detected parts
figure(2);
DisplayParts(img, parts, part_scales, 1:size(parts,3));


%% Part Grouping

% Load the trained classifier for part affinities
load part_classifier_params.mat

% Group parts
[part_labels, part_affinity, part_adjacency] = GroupSymmetricParts_SingleImage(img, parts, part_classifier_params, image_data);

% Display part groups
figure(3);
DrawPartClustersEllipses(img, parts, part_labels);

%% Part Selection

% Select non-redundant parts from each cluster
selected_parts_indicator = SelectSymmetricPart_SingleImage(parts, part_labels, part_score, part_affinity, part_adjacency);

% Display part groups after redundancy removal
figure(4);
DrawPartClustersEllipses(img, parts, part_labels, selected_parts_indicator);
