% Display the multiscale superpixels generated by Ncuts with Pb. Assume
% that there are 4 levels (25, 50, 100 and 200 superpixels) and they are
% stored in files that end with num_sups_<number>.seg
%
function DisplayMultiscaleSuperpixels(img_filename, sup_color, width)
    img = im2double(imread(img_filename));
    
    if (nargin < 2 || isempty(sup_color));
        sup_color = [0,1,0];
    end
    
    if (nargin < 3 || isempty(width))
        width = 2;
    end
    
    num_sups = [25, 50, 100, 200];
    scale = 0;
    
    for cur_num_sups = num_sups
        scale = scale + 1;
        superpixels_file = [img_filename(1:end-4),'_num_sups_',num2str(cur_num_sups),'.seg'];
        sup_image = readSeg(superpixels_file);
        boundary = bwmorph(seg2bmap(sup_image), 'dilate', width);

        row = floor((scale-1) / 2);
        col = mod((scale-1), 2);
        
        subplot('Position',[col*0.5 (2-row-1)*0.5 0.5 0.5]);
        iptsetpref('ImshowBorder', 'tight');
        imshow(display_logical(img, boundary, sup_color));
    end
