function DrawEllipse(part_ellipse, color, width, axes_handle, draw_background, bckg_color)

    if (nargin < 2 || isempty(color))
        color = 'r';
    end
    
    if (nargin < 3 || isempty(width))
        width = 3;
    end
    
    if (nargin < 4 || isempty(axes_handle))
        axes_handle = gca;
    end
    
    if (nargin < 5 || isempty(draw_background))
        draw_background = false;
    end

    if (nargin < 6 || isempty(bckg_color))
        bckg_color = 'k';
    end
    
    t = 0:0.01:2*pi;
    x = part_ellipse.a * cos(t);
    y = part_ellipse.b * sin(t);
    
    new_x = x * cos(part_ellipse.ellipse_angle) - y * sin(part_ellipse.ellipse_angle) + part_ellipse.x0;
    new_y = x * sin(part_ellipse.ellipse_angle) + y * cos(part_ellipse.ellipse_angle) + part_ellipse.y0;
    
    x = new_x;
    y = new_y;
    
    axes(axes_handle);
    if (draw_background)
        plot(x,y, 'LineWidth', width+3, 'Color', bckg_color);
    end
    
    plot(x,y, 'LineWidth', width, 'Color', color);