function [selected_parts, score] = PartClusterSelectParts(parts, cluster_parts_ind, part_strength, part_affinity, part_adjacency)

	num_cluster_parts = numel(cluster_parts_ind);
    part_cluster = parts(:, :, cluster_parts_ind);
    part_strength = part_strength(cluster_parts_ind);
    % Quadratic programming relaxion based selection
    [M,N, num_parts] = size(part_cluster);
    part_cluster = reshape(part_cluster, [M*N, num_parts]);
    
    overlap = part_cluster' * part_cluster;
    part_area = diag(overlap);
    K = 0.1*median(part_area);
    
    overlap_weight = 1-eye(num_parts, num_parts);
        
    quad_matrix = 2 * overlap .* overlap_weight;
    unary_constraint = K - part_area;
    
    annealing = linspace(0.7, 1, 10);
    selected_ind = 0.5+0.01*randn(num_parts,1);
    for i = 1:numel(annealing)
        [selected_ind,score] = minq(0, unary_constraint, quad_matrix.^annealing(i), zeros(num_parts,1), ones(num_parts,1),0, selected_ind);
    end
    selected_ind = selected_ind > 0.5;
%     selected_ind = minq(0, -part_strength(cluster_parts_ind)'*mean(diag(overlap)), -overlap .* overlap_weight, zeros(num_parts,1),ones(num_parts,1),0, rand(num_parts,1));

    selected_parts = cluster_parts_ind(selected_ind);
    
    % Select the largest connected component
%     if (numel(selected_parts)>5)
%         [ci sizes] = components(sparse((part_affinity(selected_parts, selected_parts)>0.01).*part_adjacency(selected_parts, selected_parts)));
%         [max_elements, comp_idx] = max(sizes);
%         selected_parts = selected_parts(ci == comp_idx);
%     end
    
%     % Brute force selection
%     selected_ind = zeros(num_cluster_parts, 2^num_cluster_parts);
%     
%     for i = 1:2^num_cluster_parts
%         selected_ind(:, i) = bitget(i-1, (num_cluster_parts:-1:1)');
%     end
%     
%     part_group_score = PartOverlapScore(part_cluster, selected_ind);
%     
%     [best_score, best_score_ind] = max(part_group_score);
%     selected_parts = cluster_parts_ind(selected_ind(:, best_score_ind) > 0);