function part_feature = PartFeature(part_BW)

    boundary = bwperim(part_BW);
    ordered_boundary = RegionBoundary(part_BW);
    part_ellipse = PartEllipse(part_BW);
    a = part_ellipse.a;
    b = part_ellipse.b;
    x0 = part_ellipse.x0;
    y0 = part_ellipse.y0;
    ellipse_angle = part_ellipse.ellipse_angle;
    area = part_ellipse.area;
    perim_length = sum(boundary(:));
    
    dil_boundary = bwmorph(boundary, 'dilate', 1);

    dil_proportion_small = max(1,round(b/4));
    dil_proportion_big = max(1,round(b)*2);
    
    dilated_part_small = bwmorph(part_BW, 'dilate', dil_proportion_small);
    dilated_part_big = bwmorph(part_BW, 'dilate', dil_proportion_big);
    
    area_dil_small = sum(dilated_part_small(:));
    area_dil_big = sum(dilated_part_big(:));
    
    part_feature.boundary = boundary;
    part_feature.area = area;
    part_feature.perim_length = perim_length;
    part_feature.a = a;
    part_feature.b = b;
    part_feature.x0 = x0;
    part_feature.y0 = y0;
    part_feature.ellipse_angle = ellipse_angle;
    part_feature.ordered_boundary = ordered_boundary;
    
    part_feature.dil_boundary = dil_boundary;
    part_feature.dilated_part_small = dilated_part_small;
    part_feature.dilated_part_big = dilated_part_big;
    part_feature.area_dil_small = area_dil_small;
    part_feature.area_dil_big = area_dil_big;
    