% Compute the line that best represents the medial axis of a symmetric part
% 
function axis_line = PartMedialAxisLinear(part_BW)

    stats = regionprops(double(part_BW), 'Orientation', 'MajorAxisLength', 'MinorAxisLength', 'Centroid');
    a = stats(1).MajorAxisLength/2;
    x0 = stats(1).Centroid(1);
    y0 = stats(1).Centroid(2);
    ellipse_angle = -pi*stats(1).Orientation/180;
    
    axis_line.x1 = x0 + a*cos(ellipse_angle);
    axis_line.y1 = y0 + a*sin(ellipse_angle);
    axis_line.x2 = x0 - a*cos(ellipse_angle);
    axis_line.y2 = y0 - a*sin(ellipse_angle);
