% Given the part features (fitted ellipse, boundary, etc) find the two
% straight line segments that best represent the part's boundaries
% side1 and side2 are each 4x1 vectors storing the line segments as
% [x1;y1;x2;y2]

function [side1, side2] = PartSides(part_feature)

    major_axis = PartMajorAxis(part_feature);
    shift_x = cos(part_feature.ellipse_angle-pi/2)*part_feature.b;
    shift_y = sin(part_feature.ellipse_angle-pi/2)*part_feature.b;
    
    side1 = major_axis + [shift_x; shift_y; shift_x; shift_y];
    side2 = major_axis - [shift_x; shift_y; shift_x; shift_y];
