function single_sup_affinity = SingleSuperpixelAffinity(sup_image, image_data, classifier_params, selected_features_idx)
    
    num_sups = max(sup_image(:));
    single_sup_affinity = zeros(num_sups, 1);
    
    for i = 1:num_sups
        feature = SuperpixelGroupFeature(image_data, sup_image, i, i, false);
        [ err, predictions ] = svmclassify(feature(selected_features_idx(1:100))', 1, classifier_params.svm_model);
        predictions = [predictions, 1];
        single_sup_affinity(i) = 1 / (1 + exp(-predictions * classifier_params.logistic_shape));
    end
