function [pairwise_features, adjmat, support_stats] = SuperpixelAffinityFeatures(img, image_data, pb_theta, sup_image)

    [M, N] = size(sup_image);
    adjmat = SuperpixelAdjacencyGraphNcuts(sup_image);
    sup_boundaries = SuperpixelBoundaries(sup_image);
    
    [edge_pixels, contour_pixels, adjmat] = SuperpixelEdges(sup_image, sup_boundaries, adjmat);
    num_sups = numel(sup_boundaries);
    
%     contour_assignment = SuperpixelPairContourAssign(adjmat, contour_pixels, sup_boundaries);
    stats = regionprops(sup_image, 'Centroid', 'PixelIdxList');
%     sup_centroids = reshape([stats(:).Centroid], [2, num_sups]);
    c = struct2cell(stats);
    sup_pixels = c(2,:);
    
    color_hist_affinities = SuperpixelAffinityColorHistogram(img, sup_image, adjmat);
    texture_hist_affinities = SuperpixelAffinityTextureHistogram(img, sup_image, adjmat);
%     edge_contrast = SuperpixelAffinityEdgeContrast(pb, adjmat, edge_pixels);
    [symmetry, support_stats] = SuperpixelAffinitySymmetry(sup_image, image_data, pb_theta, adjmat, sup_pixels, contour_pixels);
    
    num_symmetry_features = size(symmetry, 3);
    num_color_features = size(color_hist_affinities, 3);
    num_tex_features = size(texture_hist_affinities, 3);
    pairwise_features = zeros(num_sups, num_sups, num_color_features + num_tex_features + num_symmetry_features);
    pairwise_features(:,:,1:num_symmetry_features) = symmetry;
    
    pairwise_features(:,:,num_symmetry_features + (1:num_color_features)) = color_hist_affinities;
    pairwise_features(:,:,num_symmetry_features + num_color_features + (1:num_tex_features)) = texture_hist_affinities;
%     pairwise_features(:,:,3) = edge_contrast;
    
%     pairwise_features = SuperpixelAffinityNormalizeFeatures(pairwise_features, adjmat);
    
