function [symmetry, support_stats]  = SuperpixelAffinitySymmetry(sup_image, image_data, pb_theta, adjmat, sup_pixels, contour_pixels)

    display_on = false;
    [M,N] = size(sup_image);
    symmetry = zeros(size(adjmat,1), size(adjmat, 2), 121);
    support_stats = cell(size(adjmat));
    
    [sup1, sup2] = find(tril(adjmat, -1));
    num_edges = numel(sup1);
    
    pb = image_data.pb;
    dilated_pb = image_data.dilated_pb;

    for i = 1:num_edges
%         i

        pair_boundary = contour_pixels{sup1(i), sup2(i)};
        shape_pixels = [sup_pixels{sup1(i)}; sup_pixels{sup2(i)}];
        [symmetry_feature, supporting_stats] = RegionSymmetryFeature4(pair_boundary, shape_pixels, pb, dilated_pb, display_on);
        
%         pair_boundary = contour_pixels{sup1(i), sup2(i)};
%         shape_pixels = [sup_pixels{sup1(i)}; sup_pixels{sup2(i)}];
%         symmetry_feature = RegionSymmetryFeature2(shape_pixels, pair_boundary, pb, dilated_pb, pb_theta, display_on);

%         % Hu moments
%         BW = zeros(M,N);
%         BW(sup_pixels{sup1(i)}) = 1;
%         BW(sup_pixels{sup2(i)}) = 1;
%         symmetry_feature = humoments(BW);
        
        symmetry(sup1(i), sup2(i), :) = symmetry_feature;
        symmetry(sup2(i), sup1(i), :) = symmetry_feature;
        support_stats{sup1(i), sup2(i)} = supporting_stats;
        support_stats{sup2(i), sup1(i)} = supporting_stats;
    end
    
    symmetry(isnan(symmetry)) = 0;
    symmetry(isinf(symmetry)) = 0;
    
