function cur_affinity = SuperpixelRegionAffinityGetTrainedAffinity(cur_features, classifier_params)

    cur_features(isnan(cur_features) | isinf(cur_features)) = 0;

    switch (classifier_params.type)
        case 'svm'
            % SVM
            cur_features = [cur_features, 1];
            [ ~, predictions ] = svmclassify(cur_features(1:100), 1, classifier_params.svm_model);
            predictions = [predictions, 1];
            affinity_shape = 1 / (1 + exp(-predictions * classifier_params.logistic_shape));
            
            color_features = cur_features(:,[101:127,end]);
            num_features = numel(color_features);
            idx = tril(ones(num_features, num_features)) > 0;
            quad_features = color_features' * color_features;
            color_features = quad_features(idx(:))';
            
            affinity_color = LogisticPredict(color_features, classifier_params.logistic_color);
            
            joint_affinity = [affinity_shape, affinity_color, 1];
            cur_affinity = LogisticPredict(joint_affinity, classifier_params.logistic);
        otherwise
            error('Affinity type not implemented');
    end
